// NamespaceDoc.h
// (used by the Sandcastle Help File Builder to generate namespace documentation)

#pragma once

#include "Stdafx.h"

using namespace System;

namespace NAMESPACE_DECL {

	ref class TextDocument;
	ref class RichTextBoxEx;

	/// <summary>
	/// <para>
	/// Contains managed wrapper classes for Microsoft's Text Object Model 
	/// (TOM) interfaces (e.g. ITextDocument, ITextRange, etc).
	/// </para>
	/// <para>
	/// The top-level object in this implementation is the 
	/// <see cref="TextDocument"/> class. The most common usage scenario is to 
	/// create an instance from a <see cref="System::Windows::Forms::RichTextBox"/> 
	/// control. This library also includes the <see cref="RichTextBoxEx"/> 
	/// control, which provides access to advanced RichEdit functionality.
	/// </para>
	/// <para>
	/// For more information, refer to the 
	/// <see href="http://msdn.microsoft.com/en-us/library/windows/desktop/bb787607%28v=vs.85%29.aspx">Text Object Model</see> 
	/// documentation or visit the <see href="http://www.brad-smith.info/blog/projects/textobjectmodel">TOM Classes for .NET</see> 
	/// project page.
	/// <seealso href="http://msdn.microsoft.com/en-us/library/windows/desktop/bb787607%28v=vs.85%29.aspx">Text Object Model (Windows)</seealso> 
	/// <seealso href="http://www.brad-smith.info/blog/projects/textobjectmodel">TOM Classes for .NET</seealso> 
	/// </para>
	/// </summary>
	[System::Runtime::CompilerServices::CompilerGenerated]
	private ref class NamespaceDoc {

	};
}