// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently,
// but are changed infrequently

#pragma once

#define WIN32_LEAN_AND_MEAN

// Throws an exception for the specified HRESULT (unless S_OK)
#define THROW_HRESULT(hr) if (FAILED(hr)) Marshal::ThrowExceptionForHR(hr)

// Throws NotSupportedException
#define THROW_TOM2_ONLY() throw gcnew NotSupportedException("This operation is not supported in the Text Object Model (TOM) version 1.")

// Throws NotSupportedException if interface pointer 'x' is NULL
#define THROW_IF_NOT_INTERFACE(x) if (x == NULL) THROW_TOM2_ONLY()

// Converts tomBool value to Nullable<bool>
#define LONG_TO_NBOOL(x) (x == tomUndefined) ? Nullable<bool>() : (Nullable<bool>)(x == tomTrue)

// Converts Nullable<bool> value to tomBool
#define NBOOL_TO_LONG(x) x.HasValue ? (x.Value ? tomTrue : tomFalse) : tomUndefined

#define NAMESPACE_DECL TextObjectModel
#define NAMESPACE_CLOSE /* END */
#define NAMESPACE TextObjectModel

namespace NAMESPACE {

	// Newer version of tomConstants (from WWW)
	typedef enum __MIDL___MIDL_itf_tom_0000_0000_0001 { 
	  tomFalse                            = 0,
	  tomTrue                             = -1,
	  tomUndefined                        = -9999999,
	  tomToggle                           = -9999998,
	  tomAutoColor                        = -9999997,
	  tomDefault                          = -9999996,
	  tomSuspend                          = -9999995,
	  tomResume                           = -9999994,
	  tomApplyNow                         = 0,
	  tomApplyLater                       = 1,
	  tomTrackParms                       = 2,
	  tomCacheParms                       = 3,
	  tomApplyTmp                         = 4,
	  tomDisableSmartFont                 = 8,
	  tomEnableSmartFont                  = 9,
	  tomUsePoints                        = 10,
	  tomUseTwips                         = 11,
	  tomBackward                         = 0xc0000001,
	  tomForward                          = 0x3fffffff,
	  tomMove                             = 0,
	  tomExtend                           = 1,
	  tomNoSelection                      = 0,
	  tomSelectionIP                      = 1,
	  tomSelectionNormal                  = 2,
	  tomSelectionFrame                   = 3,
	  tomSelectionColumn                  = 4,
	  tomSelectionRow                     = 5,
	  tomSelectionBlock                   = 6,
	  tomSelectionInlineShape             = 7,
	  tomSelectionShape                   = 8,
	  tomSelStartActive                   = 1,
	  tomSelAtEOL                         = 2,
	  tomSelOvertype                      = 4,
	  tomSelActive                        = 8,
	  tomSelReplace                       = 16,
	  tomEnd                              = 0,
	  tomStart                            = 32,
	  tomCollapseEnd                      = 0,
	  tomCollapseStart                    = 1,
	  tomClientCoord                      = 256,
	  tomAllowOffClient                   = 512,
	  tomTransform                        = 1024,
	  tomObjectArg                        = 2048,
	  tomAtEnd                            = 4096,
	  tomNone                             = 0,
	  tomSingle                           = 1,
	  tomWords                            = 2,
	  tomDouble                           = 3,
	  tomDotted                           = 4,
	  tomDash                             = 5,
	  tomDashDot                          = 6,
	  tomDashDotDot                       = 7,
	  tomWave                             = 8,
	  tomThick                            = 9,
	  tomHair                             = 10,
	  tomDoubleWave                       = 11,
	  tomHeavyWave                        = 12,
	  tomLongDash                         = 13,
	  tomThickDash                        = 14,
	  tomThickDashDot                     = 15,
	  tomThickDashDotDot                  = 16,
	  tomThickDotted                      = 17,
	  tomThickLongDash                    = 18,
	  tomLineSpaceSingle                  = 0,
	  tomLineSpace1pt5                    = 1,
	  tomLineSpaceDouble                  = 2,
	  tomLineSpaceAtLeast                 = 3,
	  tomLineSpaceExactly                 = 4,
	  tomLineSpaceMultiple                = 5,
	  tomLineSpacePercent                 = 6,
	  tomAlignLeft                        = 0,
	  tomAlignCenter                      = 1,
	  tomAlignRight                       = 2,
	  tomAlignJustify                     = 3,
	  tomAlignDecimal                     = 3,
	  tomAlignBar                         = 4,
	  tomDefaultTab                       = 5,
	  tomAlignInterWord                   = 3,
	  tomAlignNewspaper                   = 4,
	  tomAlignInterLetter                 = 5,
	  tomAlignScaled                      = 6,
	  tomSpaces                           = 0,
	  tomDots                             = 1,
	  tomDashes                           = 2,
	  tomLines                            = 3,
	  tomThickLines                       = 4,
	  tomEquals                           = 5,
	  tomTabBack                          = -3,
	  tomTabNext                          = -2,
	  tomTabHere                          = -1,
	  tomListNone                         = 0,
	  tomListBullet                       = 1,
	  tomListNumberAsArabic               = 2,
	  tomListNumberAsLCLetter             = 3,
	  tomListNumberAsUCLetter             = 4,
	  tomListNumberAsLCRoman              = 5,
	  tomListNumberAsUCRoman              = 6,
	  tomListNumberAsSequence             = 7,
	  tomListNumberedCircle               = 8,
	  tomListNumberedBlackCircleWingding  = 9,
	  tomListNumberedWhiteCircleWingding  = 10,
	  tomListNumberedArabicWide           = 11,
	  tomListNumberedChS                  = 12,
	  tomListNumberedChT                  = 13,
	  tomListNumberedJpnChS               = 14,
	  tomListNumberedJpnKor               = 15,
	  tomListNumberedArabic1              = 16,
	  tomListNumberedArabic2              = 17,
	  tomListNumberedHebrew               = 18,
	  tomListNumberedThaiAlpha            = 19,
	  tomListNumberedThaiNum              = 20,
	  tomListNumberedHindiAlpha           = 21,
	  tomListNumberedHindiAlpha1          = 22,
	  tomListNumberedHindiNum             = 23,
	  tomListParentheses                  = 0x10000,
	  tomListPeriod                       = 0x20000,
	  tomListPlain                        = 0x30000,
	  tomListNoNumber                     = 0x40000,
	  tomListMinus                        = 0x80000,
	  tomIgnoreNumberStyle                = 0x1000000,
	  tomParaStyleNormal                  = -1,
	  tomParaStyleHeading1                = -2,
	  tomParaStyleHeading2                = -3,
	  tomParaStyleHeading3                = -4,
	  tomParaStyleHeading4                = -5,
	  tomParaStyleHeading5                = -6,
	  tomParaStyleHeading6                = -7,
	  tomParaStyleHeading7                = -8,
	  tomParaStyleHeading8                = -9,
	  tomParaStyleHeading9                = -10,
	  tomCharacter                        = 1,
	  tomWord                             = 2,
	  tomSentence                         = 3,
	  tomParagraph                        = 4,
	  tomLine                             = 5,
	  tomStory                            = 6,
	  tomScreen                           = 7,
	  tomSection                          = 8,
	  tomTableColumn                      = 9,
	  tomColumn                           = 9,
	  tomRow                              = 10,
	  tomWindow                           = 11,
	  tomCell                             = 12,
	  tomCharFormat                       = 13,
	  tomParaFormat                       = 14,
	  tomTable                            = 15,
	  tomObject                           = 16,
	  tomPage                             = 17,
	  tomHardParagraph                    = 18,
	  tomCluster                          = 19,
	  tomInlineObject                     = 20,
	  tomInlineObjectArg                  = 21,
	  tomLeafLine                         = 22,
	  tomLayoutColumn                     = 23,
	  tomProcessId                        = 0x40000001,
	  tomMatchWord                        = 2,
	  tomMatchCase                        = 4,
	  tomMatchPattern                     = 8,
	  tomUnknownStory                     = 0,
	  tomMainTextStory                    = 1,
	  tomFootnotesStory                   = 2,
	  tomEndnotesStory                    = 3,
	  tomCommentsStory                    = 4,
	  tomTextFrameStory                   = 5,
	  tomEvenPagesHeaderStory             = 6,
	  tomPrimaryHeaderStory               = 7,
	  tomEvenPagesFooterStory             = 8,
	  tomPrimaryFooterStory               = 9,
	  tomFirstPageHeaderStory             = 10,
	  tomFirstPageFooterStory             = 11,
	  tomScratchStory                     = 127,
	  tomFindStory                        = 128,
	  tomReplaceStory                     = 129,
	  tomStoryInactive                    = 1,
	  tomStoryActiveDisplay               = 1,
	  tomStoryActiveUI                    = 2,
	  tomStoryActiveDisplayUI             = 3,
	  tomNoAnimation                      = 0,
	  tomLasVegasLights                   = 1,
	  tomBlinkingBackground               = 2,
	  tomSparkleText                      = 3,
	  tomMarchingBlackAnts                = 4,
	  tomMarchingRedAnts                  = 5,
	  tomShimmer                          = 6,
	  tomWipeDown                         = 7,
	  tomWipeRight                        = 8,
	  tomAnimationMax                     = 8,
	  tomLowerCase                        = 0,
	  tomUpperCase                        = 1,
	  tomTitleCase                        = 2,
	  tomSentenceCase                     = 4,
	  tomToggleCase                       = 5,
	  tomReadOnly                         = 0x100,
	  tomShareDenyRead                    = 0x200,
	  tomShareDenyWrite                   = 0x400,
	  tomPasteFile                        = 0x1000,
	  tomCreateNew                        = 0x10,
	  tomCreateAlways                     = 0x20,
	  tomOpenExisting                     = 0x30,
	  tomOpenAlways                       = 0x40,
	  tomTruncateExisting                 = 0x50,
	  tomRTF                              = 0x1,
	  tomText                             = 0x2,
	  tomHTML                             = 0x3,
	  tomWordDocument                     = 0x4,
	  tomBold                             = 0x80000001,
	  tomItalic                           = 0x80000002,
	  tomUnderline                        = 0x80000004,
	  tomStrikeout                        = 0x80000008,
	  tomProtected                        = 0x80000010,
	  tomLink                             = 0x80000020,
	  tomSmallCaps                        = 0x80000040,
	  tomAllCaps                          = 0x80000080,
	  tomHidden                           = 0x80000100,
	  tomOutline                          = 0x80000200,
	  tomShadow                           = 0x80000400,
	  tomEmboss                           = 0x80000800,
	  tomImprint                          = 0x80001000,
	  tomDisabled                         = 0x80002000,
	  tomRevised                          = 0x80004000,
	  tomSubscriptCF                      = 0x80010000,
	  tomSuperscriptCF                    = 0x80020000,
	  tomFontBound                        = 0x80100000,
	  tomLinkProtected                    = 0x80800000,
	  tomInlineObjectStart                = 0x81000000,
	  tomExtendedChar                     = 0x82000000,
	  tomAutoBackColor                    = 0x84000000,
	  tomMathZoneNoBuildUp                = 0x88000000,
	  tomMathZone                         = 0x90000000,
	  tomMathZoneOrdinary                 = 0xa0000000,
	  tomAutoTextColor                    = 0xC0000000,
	  tomMathZoneDisplay                  = 0x40000,
	  tomParaEffectRTL                    = 0x1,
	  tomParaEffectKeep                   = 0x2,
	  tomParaEffectKeepNext               = 0x4,
	  tomParaEffectPageBreakBefore        = 0x8,
	  tomParaEffectNoLineNumber           = 0x10,
	  tomParaEffectNoWidowControl         = 0x20,
	  tomParaEffectDoNotHyphen            = 0x40,
	  tomParaEffectSideBySide             = 0x80,
	  tomParaEffectCollapsed              = 0x100,
	  tomParaEffectOutlineLevel           = 0x200,
	  tomParaEffectBox                    = 0x400,
	  tomParaEffectTableRowDelimiter      = 0x1000,
	  tomParaEffectTable                  = 0x4000,
	  tomModWidthPairs                    = 0x1,
	  tomModWidthSpace                    = 0x2,
	  tomAutoSpaceAlpha                   = 0x4,
	  tomAutoSpaceNumeric                 = 0x8,
	  tomAutoSpaceParens                  = 0x10,
	  tomEmbeddedFont                     = 0x20,
	  tomDoublestrike                     = 0x40,
	  tomOverlapping                      = 0x80,
	  tomNormalCaret                      = 0,
	  tomKoreanBlockCaret                 = 0x1,
	  tomNullCaret                        = 0x2,
	  tomIncludeInset                     = 0x1,
	  tomUnicodeBiDi                      = 0x1,
	  tomMathCFCheck                      = 0x4,
	  tomUnlink                           = 0x8,
	  tomUnhide                           = 0x10,
	  tomCheckTextLimit                   = 0x20,
	  tomIgnoreCurrentFont                = 0,
	  tomMatchCharRep                     = 0x1,
	  tomMatchFontSignature               = 0x2,
	  tomMatchAscii                       = 0x4,
	  tomGetHeightOnly                    = 0x8,
	  tomMatchMathFont                    = 0x10,
	  tomCharset                          = 0x80000000,
	  tomCharRepFromLcid                  = 0x40000000,
	  tomAnsi                             = 0,
	  tomEastEurope                       = 1,
	  tomCyrillic                         = 2,
	  tomGreek                            = 3,
	  tomTurkish                          = 4,
	  tomHebrew                           = 5,
	  tomArabic                           = 6,
	  tomBaltic                           = 7,
	  tomVietnamese                       = 8,
	  tomDefaultCharRep                   = 9,
	  tomSymbol                           = 10,
	  tomThai                             = 11,
	  tomShiftJIS                         = 12,
	  tomGB2312                           = 13,
	  tomHangul                           = 14,
	  tomBIG5                             = 15,
	  tomPC437                            = 16,
	  tomOEM                              = 17,
	  tomMac                              = 18,
	  tomArmenian                         = 19,
	  tomSyriac                           = 20,
	  tomThaana                           = 21,
	  tomDevanagari                       = 22,
	  tomBengali                          = 23,
	  tomGurmukhi                         = 24,
	  tomGujarati                         = 25,
	  tomOriya                            = 26,
	  tomTamil                            = 27,
	  tomTelugu                           = 28,
	  tomKannada                          = 29,
	  tomMalayalam                        = 30,
	  tomSinhala                          = 31,
	  tomLao                              = 32,
	  tomTibetan                          = 33,
	  tomMyanmar                          = 34,
	  tomGeorgian                         = 35,
	  tomJamo                             = 36,
	  tomEthiopic                         = 37,
	  tomCherokee                         = 38,
	  tomAboriginal                       = 39,
	  tomOgham                            = 40,
	  tomRunic                            = 41,
	  tomKhmer                            = 42,
	  tomMongolian                        = 43,
	  tomBraille                          = 44,
	  tomYi                               = 45,
	  tomLimbu                            = 46,
	  tomTaiLe                            = 47,
	  tomNewTaiLue                        = 48,
	  tomSylotiNagri                      = 49,
	  tomKharoshthi                       = 50,
	  tomKayahli                          = 51,
	  tomUsymbol                          = 52,
	  tomEmoji                            = 53,
	  tomGlagolitic                       = 54,
	  tomLisu                             = 55,
	  tomVai                              = 56,
	  tomNKo                              = 57,
	  tomOsmanya                          = 58,
	  tomPhagsPa                          = 59,
	  tomGothic                           = 60,
	  tomDeseret                          = 61,
	  tomTifinagh                         = 62,
	  tomCharRepMax                       = 62,
	  tomRE10Mode                         = 0x1,
	  tomUseAtFont                        = 0x2,
	  tomTextFlowMask                     = 0xc,
	  tomTextFlowES                       = 0,
	  tomTextFlowSW                       = 0x4,
	  tomTextFlowWN                       = 0x8,
	  tomTextFlowNE                       = 0xc,
	  tomNoIME                            = 0x80000,
	  tomSelfIME                          = 0x40000,
	  tomNoUpScroll                       = 0x10000,
	  tomNoVpScroll                       = 0x40000,
	  tomNoLink                           = 0,
	  tomClientLink                       = 1,
	  tomFriendlyLinkName                 = 2,
	  tomFriendlyLinkAddress              = 3,
	  tomAutoLinkURL                      = 4,
	  tomAutoLinkEmail                    = 5,
	  tomAutoLinkPhone                    = 6,
	  tomAutoLinkPath                     = 7,
	  tomCompressNone                     = 0,
	  tomCompressPunctuation              = 1,
	  tomCompressPunctuationAndKana       = 2,
	  tomCompressMax                      = 2,
	  tomUnderlinePositionAuto            = 0,
	  tomUnderlinePositionBelow           = 1,
	  tomUnderlinePositionAbove           = 2,
	  tomUnderlinePositionMax             = 2,
	  tomFontAlignmentAuto                = 0,
	  tomFontAlignmentTop                 = 1,
	  tomFontAlignmentBaseline            = 2,
	  tomFontAlignmentBottom              = 3,
	  tomFontAlignmentCenter              = 4,
	  tomFontAlignmentMax                 = 4,
	  tomLimitsDefault                    = 0,
	  tomLimitsUnderOver                  = 1,
	  tomLimitsSubSup                     = 2,
	  tomUpperLimitAsSuperScript          = 3,
	  tomLimitsOpposite                   = 4,
	  tomShowLLimPlaceHldr                = 8,
	  tomShowULimPlaceHldr                = 16,
	  tomDontGrowWithContent              = 64,
	  tomGrowWithContent                  = 128,
	  tomSubSupAlign                      = 1,
	  tomLimitAlignMask                   = 3,
	  tomLimitAlignCenter                 = 0,
	  tomLimitAlignLeft                   = 1,
	  tomLimitAlignRight                  = 2,
	  tomShowDegPlaceHldr                 = 8,
	  tomAlignDefault                     = 0,
	  tomAlignMatchAscentDescent          = 2,
	  tomMathVariant                      = 0x20,
	  tomStyleDefault                     = 0,
	  tomStyleScriptScriptCramped         = 1,
	  tomStyleScriptScript                = 2,
	  tomStyleScriptCramped               = 3,
	  tomStyleScript                      = 4,
	  tomStyleTextCramped                 = 5,
	  tomStyleText                        = 6,
	  tomStyleDisplayCramped              = 7,
	  tomStyleDisplay                     = 8,
	  tomMathRelSize                      = 0x40,
	  tomDecDecSize                       = 0xfe,
	  tomDecSize                          = 0xff,
	  tomIncSize                          = ( 1 | tomMathRelSize ),
	  tomIncIncSize                       = ( 2 | tomMathRelSize ),
	  tomGravityUI                        = 0,
	  tomGravityBack                      = 1,
	  tomGravityFore                      = 2,
	  tomGravityIn                        = 3,
	  tomGravityOut                       = 4,
	  tomTeX                              = 1,
	  tomNeedTermOp                       = 2,
	  tomMathAlphabetics                  = 4,
	  tomMathSingleChar                   = 8,
	  tomPlain                            = 16,
	  tomHaveDelimiter                    = 32,
	  tomUseOperandPrec                   = 64,
	  tomMathCollapseSel                  = 128,
	  tomMathAutoCorrect                  = 256,
	  tomMathBuildUpArgOrZone             = 512,
	  tomMathBuildUpRecurse               = 1024,
	  tomMathBuildDownOutermost           = 2048,
	  tomChemicalFormula                  = 0x1000,
	  tomMathBuildDown                    = 0x2000,
	  tomMathApplyTemplate                = 0x4000,
	  tomMathRemoveOutermost              = 0x8000,
	  tomMathChangeMask                   = 0x1f0000,
	  tomMathInsRowBefore                 = 0x10000,
	  tomMathInsRowAfter                  = 0x20000,
	  tomMathInsColBefore                 = 0x30000,
	  tomMathInsColAfter                  = 0x40000,
	  tomMathDeleteRow                    = 0x50000,
	  tomMathDeleteCol                    = 0x60000,
	  tomMathDeleteArg                    = 0x70000,
	  tomMathDeleteArg1                   = 0x80000,
	  tomMathDeleteArg2                   = 0x90000,
	  tomMathMakeFracLinear               = 0xa0000,
	  tomMathMakeFracStacked              = 0xb0000,
	  tomMathMakeFracSlashed              = 0xc0000,
	  tomMathMakeLeftSubSup               = 0xd0000,
	  tomMathMakeSubSup                   = 0xe0000,
	  tomMathBackspace                    = 0x100000,
	  tomMathEnter                        = 0x110000,
	  tomMathShiftTab                     = 0x120000,
	  tomMathTab                          = 0x130000,
	  tomMathAlignBreakLeft               = 0x140000,
	  tomMathAlignBreakCenter             = 0x150000,
	  tomMathAlignBreakRight              = 0x160000,
	  tomMathSubscript                    = 0x170000,
	  tomMathSuperscript                  = 0x180000,
	  tomMathArabicAlphabetics            = 0x800000,
	  tomMathAutoCorrectOpPairs           = 0x1000000,
	  tomMathAutoCorrectExt               = 0x2000000,
	  tomShowEmptyArgPlaceholders         = 0x4000000,
	  tomMathAutoComplete                 = 0x8000000,
	  tomMathRichEdit                     = 0x40000000,
	  tomSpecialChar                      = 0x80000000,
	  tomAdjustCRLF                       = 1,
	  tomUseCRLF                          = 2,
	  tomTextize                          = 4,
	  tomAllowFinalEOP                    = 8,
	  tomFoldMathAlpha                    = 16,
	  tomNoHidden                         = 32,
	  tomIncludeNumbering                 = 64,
	  tomTranslateTableCell               = 128,
	  tomNoMathZoneBrackets               = 0x100,
	  tomConvertMathChar                  = 0x200,
	  tomNoUCGreekItalic                  = 0x400,
	  tomAllowMathBold                    = 0x800,
	  tomLanguageTag                      = 0x1000,
	  tomConvertRTF                       = 0x2000,
	  tomApplyRtfDocProps                 = 0x4000,
	  tomPhantomShow                      = 1,
	  tomPhantomZeroWidth                 = 2,
	  tomPhantomZeroAscent                = 4,
	  tomPhantomZeroDescent               = 8,
	  tomPhantomTransparent               = 16,
	  tomPhantomASmash                    = ( tomPhantomShow | tomPhantomZeroAscent ),
	  tomPhantomDSmash                    = ( tomPhantomShow | tomPhantomZeroDescent ),
	  tomPhantomHSmash                    = ( tomPhantomShow | tomPhantomZeroWidth ),
	  tomPhantomSmash                     = ( ( tomPhantomShow | tomPhantomZeroAscent ) | tomPhantomZeroDescent ),
	  tomPhantomHorz                      = ( tomPhantomZeroAscent | tomPhantomZeroDescent ),
	  tomPhantomVert                      = tomPhantomZeroWidth,
	  tomBoxHideTop                       = 1,
	  tomBoxHideBottom                    = 2,
	  tomBoxHideLeft                      = 4,
	  tomBoxHideRight                     = 8,
	  tomBoxStrikeH                       = 16,
	  tomBoxStrikeV                       = 32,
	  tomBoxStrikeTLBR                    = 64,
	  tomBoxStrikeBLTR                    = 128,
	  tomBoxAlignCenter                   = 1,
	  tomSpaceMask                        = 0x1c,
	  tomSpaceDefault                     = 0,
	  tomSpaceUnary                       = 4,
	  tomSpaceBinary                      = 8,
	  tomSpaceRelational                  = 12,
	  tomSpaceSkip                        = 16,
	  tomSpaceOrd                         = 20,
	  tomSpaceDifferential                = 24,
	  tomSizeText                         = 32,
	  tomSizeScript                       = 64,
	  tomSizeScriptScript                 = 96,
	  tomNoBreak                          = 128,
	  tomTransparentForPositioning        = 256,
	  tomTransparentForSpacing            = 512,
	  tomStretchCharBelow                 = 0,
	  tomStretchCharAbove                 = 1,
	  tomStretchBaseBelow                 = 2,
	  tomStretchBaseAbove                 = 3,
	  tomMatrixAlignMask                  = 3,
	  tomMatrixAlignCenter                = 0,
	  tomMatrixAlignTopRow                = 1,
	  tomMatrixAlignBottomRow             = 3,
	  tomShowMatPlaceHldr                 = 8,
	  tomEqArrayLayoutWidth               = 1,
	  tomEqArrayAlignMask                 = 0xc,
	  tomEqArrayAlignCenter               = 0,
	  tomEqArrayAlignTopRow               = 4,
	  tomEqArrayAlignBottomRow            = 0xc,
	  tomMathManualBreakMask              = 0x7f,
	  tomMathBreakLeft                    = 0x7d,
	  tomMathBreakCenter                  = 0x7e,
	  tomMathBreakRight                   = 0x7f,
	  tomMathEqAlign                      = 0x80,
	  tomMathArgShadingStart              = 0x251,
	  tomMathArgShadingEnd                = 0x252,
	  tomMathObjShadingStart              = 0x253,
	  tomMathObjShadingEnd                = 0x254,
	  tomFunctionTypeNone                 = 0,
	  tomFunctionTypeTakesArg             = 1,
	  tomFunctionTypeTakesLim             = 2,
	  tomFunctionTypeTakesLim2            = 3,
	  tomFunctionTypeIsLim                = 4,
	  tomMathParaAlignDefault             = 0,
	  tomMathParaAlignCenterGroup         = 1,
	  tomMathParaAlignCenter              = 2,
	  tomMathParaAlignLeft                = 3,
	  tomMathParaAlignRight               = 4,
	  tomMathDispAlignMask                = 3,
	  tomMathDispAlignCenterGroup         = 0,
	  tomMathDispAlignCenter              = 1,
	  tomMathDispAlignLeft                = 2,
	  tomMathDispAlignRight               = 3,
	  tomMathDispIntUnderOver             = 4,
	  tomMathDispFracTeX                  = 8,
	  tomMathDispNaryGrow                 = 0x10,
	  tomMathDocEmptyArgMask              = 0x60,
	  tomMathDocEmptyArgAuto              = 0,
	  tomMathDocEmptyArgAlways            = 0x20,
	  tomMathDocEmptyArgNever             = 0x40,
	  tomMathDocSbSpOpUnchanged           = 0x80,
	  tomMathDocDiffMask                  = 0x300,
	  tomMathDocDiffDefault               = 0,
	  tomMathDocDiffUpright               = 0x100,
	  tomMathDocDiffItalic                = 0x200,
	  tomMathDocDiffOpenItalic            = 0x300,
	  tomMathDispNarySubSup               = 0x400,
	  tomMathDispDef                      = 0x800,
	  tomMathEnableRtl                    = 0x1000,
	  tomMathBrkBinMask                   = 0x30000,
	  tomMathBrkBinBefore                 = 0,
	  tomMathBrkBinAfter                  = 0x10000,
	  tomMathBrkBinDup                    = 0x20000,
	  tomMathBrkBinSubMask                = 0xc0000,
	  tomMathBrkBinSubMM                  = 0,
	  tomMathBrkBinSubPM                  = 0x40000,
	  tomMathBrkBinSubMP                  = 0x80000,
	  tomSelRange                         = 0x255,
	  tomHstring                          = 0x254,
	  tomFontPropTeXStyle                 = 0x33c,
	  tomFontPropAlign                    = 0x33d,
	  tomFontStretch                      = 0x33e,
	  tomFontStyle                        = 0x33f,
	  tomFontStyleUpright                 = 0,
	  tomFontStyleOblique                 = 1,
	  tomFontStyleItalic                  = 2,
	  tomFontStretchDefault               = 0,
	  tomFontStretchUltraCondensed        = 1,
	  tomFontStretchExtraCondensed        = 2,
	  tomFontStretchCondensed             = 3,
	  tomFontStretchSemiCondensed         = 4,
	  tomFontStretchNormal                = 5,
	  tomFontStretchSemiExpanded          = 6,
	  tomFontStretchExpanded              = 7,
	  tomFontStretchExtraExpanded         = 8,
	  tomFontStretchUltraExpanded         = 9,
	  tomFontWeightDefault                = 0,
	  tomFontWeightThin                   = 100,
	  tomFontWeightExtraLight             = 200,
	  tomFontWeightLight                  = 300,
	  tomFontWeightNormal                 = 400,
	  tomFontWeightRegular                = 400,
	  tomFontWeightMedium                 = 500,
	  tomFontWeightSemiBold               = 600,
	  tomFontWeightBold                   = 700,
	  tomFontWeightExtraBold              = 800,
	  tomFontWeightBlack                  = 900,
	  tomFontWeightHeavy                  = 900,
	  tomFontWeightExtraBlack             = 950,
	  tomParaPropMathAlign                = 0x437,
	  tomDocMathBuild                     = 0x80,
	  tomMathLMargin                      = 0x81,
	  tomMathRMargin                      = 0x82,
	  tomMathWrapIndent                   = 0x83,
	  tomMathWrapRight                    = 0x84,
	  tomMathPostSpace                    = 0x86,
	  tomMathPreSpace                     = 0x85,
	  tomMathInterSpace                   = 0x87,
	  tomMathIntraSpace                   = 0x88,
	  tomCanCopy                          = 0x89,
	  tomCanRedo                          = 0x8a,
	  tomCanUndo                          = 0x8b,
	  tomUndoLimit                        = 0x8c,
	  tomDocAutoLink                      = 0x8d,
	  tomEllipsisMode                     = 0x8e,
	  tomEllipsisState                    = 0x8f,
	  tomEllipsisNone                     = 0,
	  tomEllipsisEnd                      = 1,
	  tomEllipsisWord                     = 3,
	  tomEllipsisPresent                  = 1,
	  tomVTopCell                         = 1,
	  tomVLowCell                         = 2,
	  tomHStartCell                       = 4,
	  tomHContCell                        = 8,
	  tomRowUpdate                        = 1,
	  tomCellStructureChangeOnly          = 1,
	  tomRowHeightActual                  = 0x80b
	} tomConstants;

} NAMESPACE_CLOSE

